## quadrilateralcowboy 0~20251020.git50f5a30bd

=== CMakeLists.txt ===
# CMake File for Quadrilateral Cowboy (Because scons and Xcode are butt)
# Written by Ethan "flibitijibibo" Lee

CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
PROJECT(QuadrilateralCowboy)

# CMake Options
OPTION(STEAM "Enable Steamworks" OFF)

# Compiler Flags
IF(NOT WIN32)
	ADD_COMPILE_OPTIONS(
		-pipe
		-Wno-unknown-pragmas
		-Wno-write-strings
		-fmessage-length=0
		-fpermissive
		-fvisibility=hidden
		-fno-strict-aliasing
	)
ENDIF()
ADD_DEFINITIONS(-D_D3XP -DCTF -DID_ENABLE_CURL=0 -DUSE_SDL -DXTHREADS)
IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
	ADD_DEFINITIONS(-D_DEBUG -DID_MCHECK)
ELSEIF(CMAKE_BUILD_TYPE STREQUAL "Release")
	ADD_DEFINITIONS(-DNDEBUG)
	IF(NOT WIN32)
		ADD_COMPILE_OPTIONS(
			-Winline
			-ffast-math
			-fno-unsafe-math-optimizations
			-fomit-frame-pointer
		)
	ENDIF()
ENDIF()
IF(STEAM)
	ADD_DEFINITIONS(-DSTEAM)
	INCLUDE_DIRECTORIES(steam)
	LINK_DIRECTORIES(steam)
ENDIF()

# RPATH
IF(NOT WIN32)
	IF(APPLE)
		SET(BIN_RPATH "@executable_path/osx")
		ADD_DEFINITIONS(-DMACOS_X) # WTF? -flibit
	ELSE()
		IF(CMAKE_SIZEOF_VOID_P MATCHES 8)
			# Naming quirk for backward compatibility
			SET(BIN_RPATH "\$ORIGIN/lib64")
		ELSE()
			SET(BIN_RPATH "\$ORIGIN/lib")
		ENDIF()
		SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--disable-new-dtags")
	ENDIF()
	SET(CMAKE_SKIP_BUILD_RPATH TRUE)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
	SET(CMAKE_INSTALL_RPATH ${BIN_RPATH})
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
ENDIF()

# Source Lists
SET(QC_SRC
	renderer/Cinematic.cpp
	renderer/GuiModel.cpp
	renderer/Image_files.cpp
	renderer/Image_init.cpp
	renderer/Image_load.cpp
	renderer/Image_process.cpp
	renderer/Image_program.cpp
	renderer/Interaction.cpp
	renderer/Material.cpp
	renderer/MegaTexture.cpp
	renderer/Model.cpp
	renderer/ModelDecal.cpp
	renderer/ModelManager.cpp
	renderer/ModelOverlay.cpp
	renderer/Model_beam.cpp
	renderer/Model_ase.cpp
	renderer/Model_liquid.cpp
	renderer/Model_lwo.cpp
	renderer/Model_ma.cpp
	renderer/Model_md3.cpp
	renderer/Model_md5.cpp
	renderer/Model_prt.cpp
	renderer/Model_sprite.cpp
	renderer/RenderEntity.cpp
	renderer/RenderSystem.cpp
	renderer/RenderSystem_init.cpp
	renderer/RenderWorld.cpp
	renderer/RenderWorld_demo.cpp
	renderer/RenderWorld_load.cpp
	renderer/RenderWorld_portals.cpp
	renderer/VertexCache.cpp
	renderer/cg_explicit.cpp
	renderer/draw_arb.cpp
	renderer/draw_arb2.cpp
	renderer/draw_common.cpp
	renderer/draw_exp_stub.cpp
	renderer/draw_nv10.cpp
	renderer/draw_nv20.cpp
	renderer/draw_r200.cpp
	renderer/tr_backend.cpp
	renderer/tr_deform.cpp
	renderer/tr_font.cpp
	renderer/tr_guisurf.cpp
	renderer/tr_light.cpp
	renderer/tr_lightrun.cpp
	renderer/tr_main.cpp
	renderer/tr_orderIndexes.cpp
	renderer/tr_polytope.cpp
	renderer/tr_render.cpp
	renderer/tr_rendertools.cpp
	renderer/tr_shadowbounds.cpp
	renderer/tr_stencilshadow.cpp
	renderer/tr_subview.cpp
	renderer/tr_trace.cpp
	renderer/tr_trisurf.cpp
	renderer/tr_turboshadow.cpp
	framework/CVarSystem.cpp
	framework/CmdSystem.cpp
	framework/Common.cpp
	framework/Compressor.cpp
	framework/Console.cpp
	framework/DemoFile.cpp
	framework/DeclAF.cpp
	framework/DeclEntityDef.cpp
	framework/DeclFX.cpp
	framework/DeclManager.cpp
	framework/DeclParticle.cpp
	framework/DeclPDA.cpp
	framework/DeclSkin.cpp
	framework/DeclTable.cpp
	framework/EditField.cpp
	framework/EventLoop.cpp
	framework/File.cpp
	framework/FileSystem.cpp
	framework/KeyInput.cpp
	framework/Unzip.cpp
	framework/UsercmdGen.cpp
	framework/Session_menu.cpp
	framework/Session.cpp
	framework/async/AsyncClient.cpp
	framework/async/AsyncNetwork.cpp
	framework/async/AsyncServer.cpp
	framework/async/MsgChannel.cpp
	framework/async/NetworkSystem.cpp
	framework/async/ServerScan.cpp
	cm/CollisionModel_contacts.cpp
	cm/CollisionModel_contents.cpp
	cm/CollisionModel_debug.cpp
	cm/CollisionModel_files.cpp
	cm/CollisionModel_load.cpp
	cm/CollisionModel_rotate.cpp
	cm/CollisionModel_trace.cpp
	cm/CollisionModel_translate.cpp
	tools/compilers/dmap/dmap.cpp
	tools/compilers/dmap/facebsp.cpp
	tools/compilers/dmap/gldraw.cpp
	tools/compilers/dmap/glfile.cpp
	tools/compilers/dmap/leakfile.cpp
	tools/compilers/dmap/map.cpp
	tools/compilers/dmap/optimize.cpp
	tools/compilers/dmap/output.cpp
	tools/compilers/dmap/portals.cpp
	tools/compilers/dmap/shadowopt3.cpp
	tools/compilers/dmap/tritjunction.cpp
	tools/compilers/dmap/tritools.cpp
	tools/compilers/dmap/ubrush.cpp
	tools/compilers/dmap/usurface.cpp
	tools/compilers/dmap/optimize_gcc.cpp
	tools/compilers/aas/AASBuild.cpp
	tools/compilers/aas/AASBuild_file.cpp
	tools/compilers/aas/AASBuild_gravity.cpp
	tools/compilers/aas/AASBuild_ledge.cpp
	tools/compilers/aas/AASBuild_merge.cpp
	tools/compilers/aas/AASCluster.cpp
	tools/compilers/aas/AASFile.cpp
	tools/compilers/aas/AASFile_optimize.cpp
	tools/compilers/aas/AASFile_sample.cpp
	tools/compilers/aas/AASReach.cpp
	tools/compilers/aas/AASFileManager.cpp
	tools/compilers/aas/Brush.cpp
	tools/compilers/aas/BrushBSP.cpp
	tools/compilers/roqvq/NSBitmapImageRep.cpp
	tools/compilers/roqvq/codec.cpp
	tools/compilers/roqvq/roq.cpp
	tools/compilers/roqvq/roqParam.cpp
	tools/compilers/renderbump/renderbump.cpp
	sound/snd_cache.cpp
	sound/snd_decoder.cpp
	sound/snd_efxfile.cpp
	sound/snd_emitter.cpp
	sound/snd_shader.cpp
	sound/snd_system.cpp
	sound/snd_wavefile.cpp
	sound/snd_world.cpp
	ui/BindWindow.cpp
	ui/ChoiceWindow.cpp
	ui/DeviceContext.cpp
	ui/EditWindow.cpp
	ui/FieldWindow.cpp
	ui/GameBearShootWindow.cpp
	ui/GameBustOutWindow.cpp
	ui/GameSSDWindow.cpp
	ui/gamelaserduckwindow.cpp
	ui/GuiScript.cpp
	ui/ListGUI.cpp
	ui/ListWindow.cpp
	ui/MarkerWindow.cpp
	ui/RegExp.cpp
	ui/RenderWindow.cpp
	ui/SimpleWindow.cpp
	ui/SliderWindow.cpp
	ui/UserInterface.cpp
	ui/Window.cpp
	ui/Winvar.cpp
	idlib/bv/Bounds.cpp
	idlib/bv/Frustum.cpp
	idlib/bv/Sphere.cpp
	idlib/bv/Box.cpp
	idlib/geometry/DrawVert.cpp
	idlib/geometry/Winding2D.cpp
	idlib/geometry/Surface_SweptSpline.cpp
	idlib/geometry/Winding.cpp
	idlib/geometry/Surface.cpp
	idlib/geometry/Surface_Patch.cpp
	idlib/geometry/TraceModel.cpp
	idlib/geometry/JointTransform.cpp
	idlib/hashing/CRC32.cpp
	idlib/hashing/MD4.cpp
	idlib/hashing/MD5.cpp
	idlib/math/Angles.cpp
	idlib/math/Lcp.cpp
	idlib/math/idMath.cpp
	idlib/math/Matrix.cpp
	idlib/math/Ode.cpp
	idlib/math/Plane.cpp
	idlib/math/Pluecker.cpp
	idlib/math/Polynomial.cpp
	idlib/math/Quat.cpp
	idlib/math/Rotation.cpp
	idlib/math/Simd.cpp
	idlib/math/Simd_Generic.cpp
	idlib/math/Simd_3DNow.cpp
	idlib/math/Simd_AltiVec.cpp
	idlib/math/Simd_MMX.cpp
	idlib/math/Simd_SSE.cpp
	idlib/math/Simd_SSE2.cpp
	idlib/math/Simd_SSE3.cpp
	idlib/math/Vector.cpp
	idlib/BitMsg.cpp
	idlib/LangDict.cpp
	idlib/Lexer.cpp
	idlib/Lib.cpp
	idlib/containers/HashIndex.cpp
	idlib/Dict.cpp
	idlib/Str.cpp
	idlib/Parser.cpp
	idlib/MapFile.cpp
	idlib/CmdArgs.cpp
	idlib/Token.cpp
	idlib/Base64.cpp
	idlib/Timer.cpp
	idlib/Heap.cpp
	d3xp/AF.cpp
	d3xp/AFEntity.cpp
	d3xp/Actor.cpp
	d3xp/Camera.cpp
	d3xp/Entity.cpp
	d3xp/BrittleFracture.cpp
	d3xp/Fx.cpp
	d3xp/GameEdit.cpp
	d3xp/Game_local.cpp
	d3xp/Game_network.cpp
	d3xp/Item.cpp
	d3xp/IK.cpp
	d3xp/Light.cpp
	d3xp/Misc.cpp
	d3xp/Mover.cpp
	d3xp/Moveable.cpp
	d3xp/MultiplayerGame.cpp
	d3xp/Player.cpp
	d3xp/PlayerIcon.cpp
	d3xp/PlayerView.cpp
	d3xp/Projectile.cpp
	d3xp/Pvs.cpp
	d3xp/SecurityCamera.cpp
	d3xp/SmokeParticles.cpp
	d3xp/Sound.cpp
	d3xp/Target.cpp
	d3xp/Trigger.cpp
	d3xp/Weapon.cpp
	d3xp/WorldSpawn.cpp
	d3xp/ai/AAS.cpp
	d3xp/ai/AAS_debug.cpp
	d3xp/ai/AAS_pathing.cpp
	d3xp/ai/AAS_routing.cpp
	d3xp/ai/AI.cpp
	d3xp/ai/AI_events.cpp
	d3xp/ai/AI_pathing.cpp
	d3xp/ai/AI_Vagary.cpp
	d3xp/gamesys/DebugGraph.cpp
	d3xp/gamesys/Class.cpp
	d3xp/gamesys/Event.cpp
	d3xp/gamesys/SaveGame.cpp
	d3xp/gamesys/SysCmds.cpp
	d3xp/gamesys/SysCvar.cpp
	d3xp/gamesys/TypeInfo.cpp
	d3xp/anim/Anim.cpp
	d3xp/anim/Anim_Blend.cpp
	d3xp/anim/Anim_Import.cpp
	d3xp/anim/Anim_Testmodel.cpp
	d3xp/script/Script_Compiler.cpp
	d3xp/script/Script_Interpreter.cpp
	d3xp/script/Script_Program.cpp
	d3xp/script/Script_Thread.cpp
	d3xp/physics/Clip.cpp
	d3xp/physics/Force.cpp
	d3xp/physics/Force_Constant.cpp
	d3xp/physics/Force_Drag.cpp
	d3xp/physics/Force_Field.cpp
	d3xp/physics/Force_Spring.cpp
	d3xp/physics/Physics.cpp
	d3xp/physics/Physics_AF.cpp
	d3xp/physics/Physics_Actor.cpp
	d3xp/physics/Physics_Base.cpp
	d3xp/physics/Physics_Monster.cpp
	d3xp/physics/Physics_Parametric.cpp
	d3xp/physics/Physics_Player.cpp
	d3xp/physics/Physics_RigidBody.cpp
	d3xp/physics/Physics_Static.cpp
	d3xp/physics/Physics_StaticMulti.cpp
	d3xp/physics/Push.cpp
	d3xp/Grabber.cpp
	d3xp/physics/Force_Grab.cpp
	d3xp/laserwire.cpp
	d3xp/panel.cpp
	d3xp/picker.cpp
	d3xp/turret.cpp
	d3xp/rotdoor.cpp
	d3xp/sentry.cpp
	d3xp/lever.cpp
	d3xp/steamstats.cpp
	d3xp/itemgate.cpp
	d3xp/worldmanager.cpp
	d3xp/powerscrewgeneric.cpp
	d3xp/camturret.cpp
	d3xp/zeppelinbig.cpp
	d3xp/keypad.cpp
	d3xp/screw.cpp
	d3xp/airlock.cpp
	d3xp/powersawgeneric.cpp
	d3xp/frobcube.cpp
	d3xp/weevil.cpp
	d3xp/clock.cpp
	d3xp/contractcamera.cpp
	d3xp/steamleaderboard.cpp
	d3xp/steamremote.cpp
	d3xp/qglass.cpp
	d3xp/trembler.cpp
	d3xp/button_switcher.cpp
	d3xp/commentary.cpp
	d3xp/cybervendor.cpp
	d3xp/launcher.cpp
	d3xp/bluebox.cpp
	d3xp/camerapoint.cpp
	d3xp/jellypoint.cpp
	d3xp/worldman_moveable.cpp
	d3xp/doorfolding.cpp
	d3xp/countdowntimer.cpp
	d3xp/animloop.cpp
	d3xp/tablefold.cpp
	TypeInfo/TypeInfoGen.cpp
	sys/glimp.cpp
	sys/events.cpp
	sys/sys_local.cpp
)
IF(WIN32)
	SET(QC_SRC
		${QC_SRC}
		sys/win32/win_cpu.cpp
		sys/win32/win_glimp.cpp
		sys/win32/win_input.cpp
		sys/win32/win_main.cpp
		sys/win32/win_net.cpp
		sys/win32/win_qgl.cpp
		sys/win32/win_shared.cpp
		sys/win32/win_snd.cpp
		sys/win32/win_syscon.cpp
		sys/win32/win_taskkeyhook.cpp
		sys/win32/win_wndproc.cpp
	)
ELSE()
	SET(QC_SRC
		${QC_SRC}
		sys/stub/util_stub.cpp
		sys/posix/posix_net.cpp
		sys/posix/posix_main.cpp
		sys/posix/posix_input.cpp
		sys/posix/posix_signal.cpp
		sys/posix/posix_threads.cpp
		sys/linux/stack.cpp
	)

	IF(APPLE)
		SET(QC_SRC
			${QC_SRC}
			sys/osx/DOOMController.mm
			sys/osx/macosx_event.mm
			sys/osx/macosx_glimp.mm
			sys/osx/macosx_guids.cpp
			sys/osx/macosx_misc.mm
			sys/osx/macosx_sound.cpp
			sys/osx/PickMonitor.cpp
			sys/osx/PreferencesDialog.cpp
		)
	ELSE()
		SET(QC_SRC
			${QC_SRC}
			idlib/bv/Frustum_gcc.cpp
			sys/linux/sound_oal.cpp
			sys/linux/input.cpp
			sys/linux/glimp.cpp
			sys/linux/glimp_dlopen.cpp
			sys/linux/main.cpp
		)
	ENDIF()
ENDIF()

# Executable information
SET(CMAKE_WIN32_EXECUTABLE ON)
ADD_EXECUTABLE(qc ${QC_SRC})

set_target_properties(qc PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON)

# SDL2 Dependency (Detection pulled from FAudio)
if(WIN32)
	set(SDL2_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/sdl2/include)
	set(SDL2_LIBRARIES ${CMAKE_SOURCE_DIR}/sdl2/lib/win32/SDL2.lib)
elseif(APPLE)
	set(SDL2_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/sdl2/include)
	set(SDL2_LIBRARIES ${CMAKE_SOURCE_DIR}/sdl2/lib/osx/libSDL2-2.0.0.dylib)
endif()
if (DEFINED SDL2_INCLUDE_DIRS AND DEFINED SDL2_LIBRARIES)
	message(STATUS "using pre-defined SDL2 variables SDL2_INCLUDE_DIRS and SDL2_LIBRARIES")
	target_include_directories(qc PUBLIC "$<BUILD_INTERFACE:${SDL2_INCLUDE_DIRS}>")
	target_link_libraries(qc PUBLIC ${SDL2_LIBRARIES})
else()
	# Only try to autodetect if both SDL2 variables aren't explicitly set
	find_package(SDL2 CONFIG)
	if (TARGET SDL2::SDL2)
		message(STATUS "using TARGET SDL2::SDL2")
		target_link_libraries(qc PUBLIC SDL2::SDL2)
	elseif (TARGET SDL2)
		message(STATUS "using TARGET SDL2")
		target_link_libraries(qc PUBLIC SDL2)
	else()
		message(STATUS "no TARGET SDL2::SDL2, or SDL2, using variables")
		target_include_directories(qc PUBLIC "$<BUILD_INTERFACE:${SDL2_INCLUDE_DIRS}>")
		target_link_libraries(qc PUBLIC ${SDL2_LIBRARIES})
	endif()
endif()

# Other Dependencies
IF(APPLE)
	FIND_LIBRARY(OPENGL NAMES OpenGL)
	FIND_LIBRARY(OPENAL NAMES OpenAL)
	FIND_LIBRARY(COCOA NAMES Cocoa)
	FIND_LIBRARY(IOKIT NAMES IOKit)
	FIND_LIBRARY(COREAUDIO NAMES CoreAudio)
	TARGET_LINK_LIBRARIES(qc PUBLIC objc ${OPENGL} ${OPENAL} ${COCOA} ${IOKIT} ${COREAUDIO})

=== debian/changelog ===
quadrilateralcowboy (0~20251020.git50f5a30bd-1) unstable; urgency=medium

  [ James Addison ]
  * Initial release. Closes: #1026277

 -- James Addison <jay@jp-hosting.net>  Mon, 20 Oct 2025 11:52:23 +0100

=== debian/control ===
Source: quadrilateralcowboy
Section: contrib/games
Priority: optional
Maintainer: James Addison <jay@jp-hosting.net>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 m4,
 libjpeg62-turbo-dev,
 libopenal-dev,
 libsdl2-dev,
 libvorbis-dev,
Standards-Version: 4.7.0
Homepage: https://www.blendogames.com/qc/
Vcs-Browser: https://salsa.debian.org/jayaddison/quadrilateralcowboy/
Vcs-Git: https://salsa.debian.org/jayaddison/quadrilateralcowboy.git/
Rules-Requires-Root: no

Package: quadrilateralcowboy
Architecture: i386 amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 quadrilateralcowboy-data | game-data-packager,
Description: first-person cyberpunk adventure game
 Quadrilateral Cowboy is self-described as "a first-person hacking adventure in
 a cyberpunk world".
 .
 The game features elements of programming, automation and puzzle-solving in a
 variety of 3D environments.
 .
 Data files for the game are not included in this package and can be purchased
 from the game's website at https://www.blendogames.com/qc/

## quadrilateralcowboy 0~20251124.gitcc4b1cd45+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,8 +59,79 @@
 	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
 ENDIF()
 
+# Include Directories
+INCLUDE_DIRECTORIES(. sound/OggVorbis/vorbissrc/)
+
 # Source Lists
 SET(QC_SRC
+	renderer/jpeg-6/jcapimin.c
+	renderer/jpeg-6/jccoefct.c
+	renderer/jpeg-6/jccolor.c
+	renderer/jpeg-6/jcdctmgr.c
+	renderer/jpeg-6/jchuff.c
+	renderer/jpeg-6/jcinit.c
+	renderer/jpeg-6/jcmainct.c
+	renderer/jpeg-6/jcmarker.c
+	renderer/jpeg-6/jcmaster.c
+	renderer/jpeg-6/jcomapi.c
+	renderer/jpeg-6/jcparam.c
+	renderer/jpeg-6/jcphuff.c
+	renderer/jpeg-6/jcprepct.c
+	renderer/jpeg-6/jcsample.c
+	renderer/jpeg-6/jdapimin.c
+	renderer/jpeg-6/jdapistd.c
+	renderer/jpeg-6/jdatadst.c
+	renderer/jpeg-6/jdatasrc.c
+	renderer/jpeg-6/jdcoefct.c
+	renderer/jpeg-6/jdcolor.c
+	renderer/jpeg-6/jddctmgr.c
+	renderer/jpeg-6/jdhuff.c
+	renderer/jpeg-6/jdinput.c
+	renderer/jpeg-6/jdmainct.c
+	renderer/jpeg-6/jdmarker.c
+	renderer/jpeg-6/jdmaster.c
+	renderer/jpeg-6/jdmerge.c
+	renderer/jpeg-6/jdphuff.c
+	renderer/jpeg-6/jdpostct.c
+	renderer/jpeg-6/jdsample.c
+	renderer/jpeg-6/jdtrans.c
+	renderer/jpeg-6/jerror.c
+	renderer/jpeg-6/jfdctflt.c
+	renderer/jpeg-6/jfdctfst.c
+	renderer/jpeg-6/jfdctint.c
+	renderer/jpeg-6/jidctflt.c
+	renderer/jpeg-6/jidctfst.c
+	renderer/jpeg-6/jidctint.c
+	renderer/jpeg-6/jidctred.c
+	renderer/jpeg-6/jmemmgr.c
+	renderer/jpeg-6/jmemnobs.c
+	renderer/jpeg-6/jquant1.c
+	renderer/jpeg-6/jquant2.c
+	renderer/jpeg-6/jutils.c
+	sound/OggVorbis/oggsrc/bitwise.c
+	sound/OggVorbis/oggsrc/framing.c
+	sound/OggVorbis/vorbissrc/analysis.c
+	sound/OggVorbis/vorbissrc/bitrate.c
+	sound/OggVorbis/vorbissrc/block.c
+	sound/OggVorbis/vorbissrc/codebook.c
+	sound/OggVorbis/vorbissrc/envelope.c
+	sound/OggVorbis/vorbissrc/floor0.c
+	sound/OggVorbis/vorbissrc/floor1.c
+	sound/OggVorbis/vorbissrc/info.c
+	sound/OggVorbis/vorbissrc/lookup.c
+	sound/OggVorbis/vorbissrc/lpc.c
+	sound/OggVorbis/vorbissrc/lsp.c
+	sound/OggVorbis/vorbissrc/mapping0.c
+	sound/OggVorbis/vorbissrc/mdct.c
+	sound/OggVorbis/vorbissrc/psy.c
+	sound/OggVorbis/vorbissrc/registry.c
+	sound/OggVorbis/vorbissrc/res0.c
+	sound/OggVorbis/vorbissrc/sharedbook.c
+	sound/OggVorbis/vorbissrc/smallft.c
+	sound/OggVorbis/vorbissrc/synthesis.c
+	sound/OggVorbis/vorbissrc/vorbisenc.c
+	sound/OggVorbis/vorbissrc/vorbisfile.c
+	sound/OggVorbis/vorbissrc/windowvb.c
 	renderer/Cinematic.cpp
 	renderer/GuiModel.cpp
 	renderer/Image_files.cpp
@@ -399,76 +470,3 @@
 		sys/posix/posix_main.cpp
 		sys/posix/posix_input.cpp
 		sys/posix/posix_signal.cpp
-		sys/posix/posix_threads.cpp
-		sys/linux/stack.cpp
-	)
-
-	IF(APPLE)
-		SET(QC_SRC
-			${QC_SRC}
-			sys/osx/DOOMController.mm
-			sys/osx/macosx_event.mm
-			sys/osx/macosx_glimp.mm
-			sys/osx/macosx_guids.cpp
-			sys/osx/macosx_misc.mm
-			sys/osx/macosx_sound.cpp
-			sys/osx/PickMonitor.cpp
-			sys/osx/PreferencesDialog.cpp
-		)
-	ELSE()
-		SET(QC_SRC
-			${QC_SRC}
-			idlib/bv/Frustum_gcc.cpp
-			sys/linux/sound_oal.cpp
-			sys/linux/input.cpp
-			sys/linux/glimp.cpp
-			sys/linux/glimp_dlopen.cpp
-			sys/linux/main.cpp
-		)
-	ENDIF()
-ENDIF()
-
-# Executable information
-SET(CMAKE_WIN32_EXECUTABLE ON)
-ADD_EXECUTABLE(qc ${QC_SRC})
-
-set_target_properties(qc PROPERTIES
-    CXX_STANDARD 11
-    CXX_STANDARD_REQUIRED ON)
-
-# SDL2 Dependency (Detection pulled from FAudio)
-if(WIN32)
-	set(SDL2_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/sdl2/include)
-	set(SDL2_LIBRARIES ${CMAKE_SOURCE_DIR}/sdl2/lib/win32/SDL2.lib)
-elseif(APPLE)
-	set(SDL2_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/sdl2/include)
-	set(SDL2_LIBRARIES ${CMAKE_SOURCE_DIR}/sdl2/lib/osx/libSDL2-2.0.0.dylib)
-endif()
-if (DEFINED SDL2_INCLUDE_DIRS AND DEFINED SDL2_LIBRARIES)
-	message(STATUS "using pre-defined SDL2 variables SDL2_INCLUDE_DIRS and SDL2_LIBRARIES")
-	target_include_directories(qc PUBLIC "$<BUILD_INTERFACE:${SDL2_INCLUDE_DIRS}>")
-	target_link_libraries(qc PUBLIC ${SDL2_LIBRARIES})
-else()
-	# Only try to autodetect if both SDL2 variables aren't explicitly set
-	find_package(SDL2 CONFIG)
-	if (TARGET SDL2::SDL2)
-		message(STATUS "using TARGET SDL2::SDL2")
-		target_link_libraries(qc PUBLIC SDL2::SDL2)
-	elseif (TARGET SDL2)
-		message(STATUS "using TARGET SDL2")
-		target_link_libraries(qc PUBLIC SDL2)
-	else()
-		message(STATUS "no TARGET SDL2::SDL2, or SDL2, using variables")
-		target_include_directories(qc PUBLIC "$<BUILD_INTERFACE:${SDL2_INCLUDE_DIRS}>")
-		target_link_libraries(qc PUBLIC ${SDL2_LIBRARIES})
-	endif()
-endif()
-
-# Other Dependencies
-IF(APPLE)
-	FIND_LIBRARY(OPENGL NAMES OpenGL)
-	FIND_LIBRARY(OPENAL NAMES OpenAL)
-	FIND_LIBRARY(COCOA NAMES Cocoa)
-	FIND_LIBRARY(IOKIT NAMES IOKit)
-	FIND_LIBRARY(COREAUDIO NAMES CoreAudio)
-	TARGET_LINK_LIBRARIES(qc PUBLIC objc ${OPENGL} ${OPENAL} ${COCOA} ${IOKIT} ${COREAUDIO})

=== SConstruct ===
# -*- mode: python -*-
# DOOM build script
# TTimo <ttimo@idsoftware.com>
# http://scons.sourceforge.net

import sys, os, time, commands, re, pickle, StringIO, popen2, commands, pdb, zipfile, string
import SCons

sys.path.append( 'sys/scons' )
import scons_utils

conf_filename='site.conf'
# choose configuration variables which should be saved between runs
# ( we handle all those as strings )
serialized=['CC', 'CXX', 'JOBS', 'BUILD', 'IDNET_HOST', 'GL_HARDLINK', 'DEDICATED',
	'DEBUG_MEMORY', 'LIBC_MALLOC', 'ID_NOLANADDRESS', 'ID_MCHECK', 'ALSA',
	'TARGET_CORE', 'TARGET_GAME', 'TARGET_D3XP', 'TARGET_MONO', 'TARGET_MONO_D3XP',
	'TARGET_DEMO', 'NOCURL', 'BUILD_ROOT', 'BUILD_GAMEPAK', 'BASEFLAGS', 'SILENT',
	'STEAM' ]

# global build mode ------------------------------

g_sdk = not os.path.exists( 'sys/scons/SConscript.core' )

# ------------------------------------------------

# help -------------------------------------------

help_string = """
Usage: scons [OPTIONS] [TARGET] [CONFIG]

[OPTIONS] and [TARGET] are covered in command line options, use scons -H

[CONFIG]: KEY="VALUE" [...]
a number of configuration options saved between runs in the """ + conf_filename + """ file
erase """ + conf_filename + """ to start with default settings again

CC (default gcc)
CXX (default g++)
	Specify C and C++ compilers (defaults gcc and g++)
	ex: CC="gcc-3.3"
	You can use ccache and distcc, for instance:
	CC="ccache distcc gcc" CXX="ccache distcc g++"

JOBS (default 1)
	Parallel build

BUILD (default debug)
	Use debug-all/debug/release to select build settings
	ex: BUILD="release"
	debug-all: no optimisations, debugging symbols
	debug: -O -g
	release: all optimisations, including CPU target etc.

BUILD_ROOT (default 'build')
	change the build root directory

TARGET_GAME (default 0)
	Build the base game code

TARGET_D3XP (default 0)
	Build the d3xp game code

BUILD_GAMEPAK (default 0)
	Build a game pak

BASEFLAGS (default '')
	Add compile flags

NOCONF (default 0, not saved)
	ignore site configuration and use defaults + command line only
	
SILENT ( default 0, saved )
	hide the compiler output, unless error

STEAM ( default 0, saved )
	enable steam build or not
"""

if ( not g_sdk ):
	help_string += """
DEDICATED (default 0)
	Control regular / dedicated type of build:
	0 - client
	1 - dedicated server
	2 - both

TARGET_CORE (default 0)
	Build the core

TARGET_MONO (default 0)
	Build a monolithic binary

TARGET_MONO_D3XP (default 1)
	Build a monolithis binary of d3xp

TARGET_DEMO (default 0)
	Build demo client ( both a core and game, no mono )
	NOTE: if you *only* want the demo client, set TARGET_CORE and TARGET_GAME to 0

IDNET_HOST (default to source hardcoded)
	Override builtin IDNET_HOST with your own settings
	
GL_HARDLINK (default 0)
	Instead of dynamically loading the OpenGL libraries, use implicit dependencies
	NOTE: no GL logging capability and no r_glDriver with GL_HARDLINK 1

DEBUG_MEMORY (default 0)
	Enables memory logging to file
	
LIBC_MALLOC (default 1)
	Toggle idHeap memory / libc malloc usage
	When libc malloc is on, memory size statistics are wrong ( no _msize )

ID_NOLANADDRESS (default 0)
	Don't recognize any IP as LAN address. This is useful when debugging network
	code where LAN / not LAN influences application behaviour
	
ID_MCHECK (default 2)
	Perform heap consistency checking
	0: on in Debug / off in Release
	1 forces on, 2 forces off
	note that Doom has it's own block allocator/checking
	this should not be considered a replacement, but an additional tool

ALSA (default 1)
	enable ALSA sound backend support
	
SETUP (default 0, not saved)
    build a setup. implies release build

SDK (default 0, not saved)
	build an SDK release

NOCURL (default 1)
	set to 1 to disable usage of libcurl and http/ftp downloads feature
"""

Help( help_string )

# end help ---------------------------------------

# sanity -----------------------------------------

EnsureSConsVersion( 0, 96 )

# end sanity -------------------------------------

# system detection -------------------------------

# CPU type
cpu = commands.getoutput('uname -m')
exp = re.compile('.*i?86.*')
if exp.match(cpu):
	cpu = 'x86_64'
else:
	cpu = commands.getoutput('uname -p')
	if ( cpu == 'powerpc' ):
		cpu = 'ppc'
	else:
		cpu = 'cpu'
g_os = 'Linux'

# end system detection ---------------------------

# default settings -------------------------------

CC = 'gcc'
CXX = 'g++'
JOBS = '1'
BUILD = 'debug'
DEDICATED = '0'
TARGET_CORE = '0'
TARGET_GAME = '0'
TARGET_D3XP = '0'
TARGET_MONO = '0'
TARGET_MONO_D3XP = '1'
TARGET_DEMO = '0'
IDNET_HOST = ''
GL_HARDLINK = '0'
DEBUG_MEMORY = '0'
LIBC_MALLOC = '1'
ID_NOLANADDRESS = '0'
ID_MCHECK = '2'
BUILD_ROOT = 'build'
ALSA = '1'
SETUP = '0'
SDK = '0'
NOCONF = '0'
NOCURL = '1'
BUILD_GAMEPAK = '0'
BASEFLAGS = ''
SILENT = '0'
STEAM = '0'

# end default settings ---------------------------

# site settings ----------------------------------

if ( not ARGUMENTS.has_key( 'NOCONF' ) or ARGUMENTS['NOCONF'] != '1' ):
	site_dict = {}
	if (os.path.exists(conf_filename)):
		site_file = open(conf_filename, 'r')
		p = pickle.Unpickler(site_file)
		site_dict = p.load()
		print 'Loading build configuration from ' + conf_filename + ':'
		for k, v in site_dict.items():
			exec_cmd = k + '=\'' + v + '\''
			print '  ' + exec_cmd
			exec(exec_cmd)
else:
	print 'Site settings ignored'

# end site settings ------------------------------

# command line settings --------------------------

for k in ARGUMENTS.keys():
	exec_cmd = k + '=\'' + ARGUMENTS[k] + '\''
	print 'Command line: ' + exec_cmd
	exec( exec_cmd )

# end command line settings ----------------------

# save site configuration ----------------------

if ( not ARGUMENTS.has_key( 'NOCONF' ) or ARGUMENTS['NOCONF'] != '1' ):
	for k in serialized:
		exec_cmd = 'site_dict[\'' + k + '\'] = ' + k
		exec(exec_cmd)

	site_file = open(conf_filename, 'w')
	p = pickle.Pickler(site_file)
	p.dump(site_dict)
	site_file.close()

# end save site configuration ------------------

# configuration rules --------------------------

if ( SETUP != '0' ):
	DEDICATED	= '2'
	BUILD		= 'release'

if ( g_sdk or SDK != '0' ):
	TARGET_CORE = '0'
	TARGET_GAME = '0'
	TARGET_D3XP = '0'
	TARGET_MONO = '0'
	TARGET_MONO_D3XP = '1'
	TARGET_DEMO = '0'

# end configuration rules ----------------------

# general configuration, target selection --------

g_build = BUILD_ROOT + '/' + BUILD

SConsignFile( 'scons.signatures' )

if ( GL_HARDLINK != '0' ):
	g_build += '-hardlink'

if ( DEBUG_MEMORY != '0' ):
	g_build += '-debugmem'
	
if ( LIBC_MALLOC != '1' ):
	g_build += '-nolibcmalloc'

SetOption('num_jobs', JOBS)

LINK = CXX

# common flags
# BASE + CORE + OPT for engine
# BASE + GAME + OPT for game
# _noopt versions of the environements are built without the OPT

BASECPPFLAGS = [ ]
CORECPPPATH = [ ]
CORELIBPATH = [ ]
CORECPPFLAGS = [ ]
GAMECPPFLAGS = [ ]
BASELINKFLAGS = [ ]
CORELINKFLAGS = [ ]

# for release build, further optimisations that may not work on all files
OPTCPPFLAGS = [ ]

BASECPPFLAGS.append( BASEFLAGS )
BASECPPFLAGS.append( '-pipe' )
# warn all
# flibit removed: BASECPPFLAGS.append( '-Wall' )
BASECPPFLAGS.append( '-Wno-unknown-pragmas' )
BASECPPFLAGS.append( '-Wno-write-strings' )
# this define is necessary to make sure threading support is enabled in X
CORECPPFLAGS.append( '-DXTHREADS' )
# don't wrap gcc messages
BASECPPFLAGS.append( '-fmessage-length=0' )
# gcc 4.0
BASECPPFLAGS.append( '-fpermissive' )

if ( g_os == 'Linux' ):
	# gcc 4.x option only - only export what we mean to from the game SO
	BASECPPFLAGS.append( '-fvisibility=hidden' )
	# get the 64 bits machine on the distcc array to produce 32 bit binaries :)
	# BASECPPFLAGS.append( '-m32' )
	# BASELINKFLAGS.append( '-m32' )
	#rpath
	#BASELINKFLAGS.append( '-Wl,-rpath=\$$ORIGIN/lib' )
	BASELINKFLAGS.append( '-Wl,-rpath=\$$ORIGIN/lib64' )

if ( g_sdk or SDK != '0' ):
	BASECPPFLAGS.append( '-D_D3SDK' )

if ( BUILD == 'debug-all' ):
	OPTCPPFLAGS = [ '-g', '-D_DEBUG' ]
	if ( ID_MCHECK == '0' ):
		ID_MCHECK = '1'
elif ( BUILD == 'debug' ):
	OPTCPPFLAGS = [ '-g', '-O1', '-D_DEBUG' ]
	if ( ID_MCHECK == '0' ):
		ID_MCHECK = '1'
elif ( BUILD == 'release' ):
	# -fomit-frame-pointer: "-O also turns on -fomit-frame-pointer on machines where doing so does not interfere with debugging."
	#   on x86 have to set it explicitely
	# -march=pentium3: flibit removed this, wtf 2004
	# -finline-functions: implicit at -O3
	# -fschedule-insns2: implicit at -O2
	# no-unsafe-math-optimizations: that should be on by default really. hit some wonko bugs in physics code because of that
	OPTCPPFLAGS = [ '-O3', '-Winline', '-ffast-math', '-fno-unsafe-math-optimizations', '-fomit-frame-pointer' ]
	if ( ID_MCHECK == '0' ):
		ID_MCHECK = '2'
else:
	print 'Unknown build configuration ' + BUILD
	sys.exit(0)

if ( GL_HARDLINK != '0' ):
	CORECPPFLAGS.append( '-DID_GL_HARDLINK' )

if ( DEBUG_MEMORY != '0' ):
	BASECPPFLAGS += [ '-DID_DEBUG_MEMORY', '-DID_REDIRECT_NEWDELETE' ]
	
if ( LIBC_MALLOC != '1' ):
	BASECPPFLAGS.append( '-DUSE_LIBC_MALLOC=0' )

if ( len( IDNET_HOST ) ):
	CORECPPFLAGS.append( '-DIDNET_HOST=\\"%s\\"' % IDNET_HOST)

if ( ID_NOLANADDRESS != '0' ):
	CORECPPFLAGS.append( '-DID_NOLANADDRESS' )
	
if ( ID_MCHECK == '1' ):
	BASECPPFLAGS.append( '-DID_MCHECK' )

# use sdl to make certain things work better
BASECPPFLAGS.append( '-DUSE_SDL' )
CORECPPPATH.append( '../../sdl2/include' )
CORELIBPATH.append( '../../sdl2/lib/linux' )

# steam settings
if (STEAM == '1'):
	BASECPPFLAGS.append( '-DSTEAM' )
	CORECPPPATH.append( '../../steam' )
	CORELIBPATH.append( '../../steam' )
	
# create the build environements
g_base_env = Environment( ENV = os.environ, CC = CC, CXX = CXX, LINK = LINK, CPPFLAGS = BASECPPFLAGS, LINKFLAGS = BASELINKFLAGS, CPPPATH = CORECPPPATH, LIBPATH = CORELIBPATH )
scons_utils.SetupUtils( g_base_env )

g_env = g_base_env.Clone()

#g_env.Append( RPATH = g_env.Literal(os.path.join('\\$$ORIGIN', 'lib') ) )

g_env['CPPFLAGS'] += OPTCPPFLAGS
g_env['CPPFLAGS'] += CORECPPFLAGS
g_env['LINKFLAGS'] += CORELINKFLAGS

g_env_noopt = g_base_env.Clone()
g_env_noopt['CPPFLAGS'] += CORECPPFLAGS

g_game_env = g_base_env.Clone()
g_game_env['CPPFLAGS'] += OPTCPPFLAGS
g_game_env['CPPFLAGS'] += GAMECPPFLAGS

# maintain this dangerous optimization off at all times
g_env.Append( CPPFLAGS = '-fno-strict-aliasing' )
g_env_noopt.Append( CPPFLAGS = '-fno-strict-aliasing' )
g_game_env.Append( CPPFLAGS = '-fno-strict-aliasing' )

if ( int(JOBS) > 1 ):
	print 'Using buffered process output'
	silent = False
	if ( SILENT == '1' ):
		silent = True
	scons_utils.SetupBufferedOutput( g_env, silent )
	scons_utils.SetupBufferedOutput( g_game_env, silent )

# mark the globals

local_dedicated = 0
# 0 for monolithic build
local_gamedll = 1
# carry around rather than using .a, avoids binutils bugs
idlib_objects = []
game_objects = []
local_demo = 0
# curl usage. there is a global toggle flag
local_curl = 0
curl_lib = []
# if idlib should produce PIC objects ( depending on core or game inclusion )
local_idlibpic = 0
# switch between base game build and d3xp game build
local_d3xp = 1

GLOBALS = 'g_env g_env_noopt g_game_env g_os ID_MCHECK ALSA idlib_objects game_objects local_dedicated local_gamedll local_demo local_idlibpic curl_lib local_curl local_d3xp OPTCPPFLAGS STEAM'

# end general configuration ----------------------

# targets ----------------------------------------

Export( 'GLOBALS ' + GLOBALS )

doom = None
doomded = None
game = None
doom_mono = None
doom_demo = None
game_demo = None

# build curl if needed
if ( NOCURL == '0' and ( TARGET_CORE == '1' or TARGET_MONO == '1' or TARGET_MONO_D3XP == '1' ) ):
	# 1: debug, 2: release
	if ( BUILD == 'release' ):
		local_curl = 2
	else:
		local_curl = 1
	Export( 'GLOBALS ' + GLOBALS )
	curl_lib = SConscript( 'sys/scons/SConscript.curl' )

if ( TARGET_CORE == '1' ):
	local_gamedll = 1
	local_demo = 0
	local_idlibpic = 0
	if ( DEDICATED == '0' or DEDICATED == '2' ):
		local_dedicated = 0

=== debian/changelog ===
quadrilateralcowboy (0~20251124.gitcc4b1cd45+dfsg-1) unstable; urgency=medium

  [ James Addison ]
  * Initial release. Closes: #1026277

 -- James Addison <jay@jp-hosting.net>  Mon, 24 Nov 2025 11:04:06 +0000

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,6 @@
 Homepage: https://www.blendogames.com/qc/
 Vcs-Browser: https://salsa.debian.org/jayaddison/quadrilateralcowboy/
 Vcs-Git: https://salsa.debian.org/jayaddison/quadrilateralcowboy.git/
-Rules-Requires-Root: no
 
 Package: quadrilateralcowboy
 Architecture: i386 amd64

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# Generate glimp C code and header files
execute_before_dh_auto_configure:
	./flibitGLIMP.sh

# Compress the manual for distribution with the package
execute_after_dh_auto_build:
	gzip --keep ./qc.6

# Cleanup to allow package rebuilds
execute_after_dh_auto_clean:
	rm -f ./qc.6.gz
	rm -f ./sys/linux/glimp_dlopen.cpp
	rm -f ./sys/linux/glimp_local.h

=== debian/watch ===
# Quadrilateral Cowboy's source code is published at:
#
# https://github.com/BlendoGames/quadrilateralcowboy.git/
#
# At the time of writing, it doesn't include any release tags or versioning
# information that uscan could use to meaningfully identify release-ready
# updated versions.
